/* GCC */

#include <functional>
#include <fstream>
#include <vector>

const unsigned int uninitialized = 1000*1000*1000;

const int quartierDelay = 60;

struct Vertex
{
    int x,y;
};

Vertex vertex(int x,int y)
{
    Vertex answer = {x,y};
    return answer;
}

int toHash(int m,int n,Vertex v)
{
    return v.y * (2*m) + v.x;
}

Vertex fromHash(int m,int n,int h)
{
    return vertex(h % (2*m),h / (2*m));
}

void fillTimeTable(const std::vector<std::vector<int> >& delay,std::vector<int>& time,
                   std::vector<bool>& locked,int current,int finish,int currentTime)
{
    if(time[current] != uninitialized)
        return;
    if(current == finish)
    {
        time[current] = std::min(time[current],currentTime);
        return;
    }
    Vertex forcheck = fromHash(delay.front().size(),delay.size(),current);
    if(forcheck.x < 0 || forcheck.x >= 2*delay.front().size() ||
       forcheck.y < 0 || forcheck.y >= 2*delay.size())
        return;
    if(!locked[current])
    {
        locked[current] = true;
        Vertex v = fromHash(delay.front().size(),delay.size(),current);
        if(v.x % 2 == 0)
        {
            Vertex next = v;
            next.x++;
            int nextTime;
            if((currentTime / delay[next.x/2][next.y/2]) % 2 == 0)
                nextTime = currentTime + 1;
            else
                nextTime = (currentTime / delay[next.y/2][next.x/2] + 1)* delay[next.x/2][next.y/2];
            fillTimeTable(delay,time,locked,toHash(delay.front().size(),delay.size(),next),finish,nextTime);
            time[current] = std::min(time[current],time[toHash(delay.front().size(),delay.size(),next)]);
        }
        else
        {
            Vertex next = v;
            next.x++;
            int nextTime = currentTime + quartierDelay;
            fillTimeTable(delay,time,locked,toHash(delay.front().size(),delay.size(),next),finish,nextTime);
            time[current] = std::min(time[current],time[toHash(delay.front().size(),delay.size(),next)]);
        }
        if(v.y % 2 == 0)
        {
            Vertex next = v;
            next.y--;
            int nextTime;
            if((currentTime / delay[next.x/2][next.y/2]) % 2 == 1)
                nextTime = currentTime + 1;
            else
                nextTime = (currentTime / delay[next.y/2][next.x/2] + 1)* delay[next.x/2][next.y/2];
            fillTimeTable(delay,time,locked,toHash(delay.front().size(),delay.size(),next),finish,nextTime);
            time[current] = std::min(time[current],time[toHash(delay.front().size(),delay.size(),next)]);
        }
        else
        {
            Vertex next = v;
            next.y--;
            int nextTime = currentTime + quartierDelay;
            fillTimeTable(delay,time,locked,toHash(delay.front().size(),delay.size(),next),finish,nextTime);
            time[current] = std::min(time[current],time[toHash(delay.front().size(),delay.size(),next)]);
        }
        locked[current] = false;
    }
}

int main()
{
    std::ifstream in("school.in");
    int m,n;
    in >> n >> m;
    std::vector<std::vector<int> > delay(n,std::vector<int>(m));
    for(int i = 0;i < n;i++)
        for(int j = 0;j < m;j++)
            in >> delay[i][j];
    in.close();
    std::vector<int> time(4*m*n,uninitialized);
    std::vector<bool> locked(4*m*n);
    fillTimeTable(delay,time,locked,toHash(m,n,vertex(0,n-1)),toHash(m,n,vertex(m-1,0)),0);
    std::ofstream out("school.out");
    out << time[toHash(m,n,vertex(m-1,0))] << std::endl;
    out.close();
}
