/* GCC */
#include <iostream>
#include <cmath>
#include <algorithm>
using namespace std;

// CONSTANTS
// DEBUG
const int DEBUG = 0;
const int INF = 100000000;
int times[256][256][4];
bool minrch[256][256][4];
int dt[256][256];
int n, m;
// Input & output
char in[] = "school.in";
char out[] = "school.out";
int getmin(int &h, int &w, int &t){
    int min = INF;
    for(int z = 1; z < m+1; z++)
      for(int p = 1; p < n+1; p++)
        for(int k = 0; k < 4; k++)
          if (times[z][p][k] < min && !minrch[z][p][k]){ min = times[z][p][k]; h = z; w = p; t = k;}
    return min;
}

int getcross(int h, int w, int curtime, int n){
    int curpos = (curtime/dt[h][w])%2; // 0 - , 1 - 
    if (curpos == n) return 1;
    return dt[h][w]-(curtime%dt[h][w])+1;
}

int main(){
    if (!DEBUG) freopen(in, "r", stdin);
    if (!DEBUG) freopen(out, "w", stdout);
    scanf("%d %d", &n, &m);
    for(int i = 1; i < m+1; i++)
      for(int j = 1; j < n+1; j++)
        scanf("%d", &dt[i][j]);
    for(int i = 0; i < 256; i++)
      for(int j = 0; j < 256; j++)
        for(int k = 0; k < 4; k++){
          minrch[i][j][k] = false;
          times[i][j][k] = INF;
        }
    times[m][1][0] = 0;
    int k, h, w, time;
    h = 0; w = 0; k = 0; time = 0;
    while(true){
      time = getmin(h, w, k);
      minrch[h][w][k] = true;
      if ((h == 1) && (w == n) && (k == 3)) goto end;
      if (k == 3){
            times[h][w][1] = min(times[h][w][1], time+getcross(h, w, time, 1));
            if (h != 1) times[h-1][w][1] = min(times[h-1][w][1], time+60);
            if (w != n) times[h][w+1][2] = min(times[h][w+1][2], time+60);
            times[h][w][2] = min(times[h][w][2], time+getcross(h, w, time, 0));
      }
      if (k == 2){
            times[h][w][0] = min(times[h][w][0], time+getcross(h, w, time, 1));
            if (h != 1) times[h-1][w][0] = min(times[h-1][w][0], time+60);
            times[h][w][3] = min(times[h][w][3], time+getcross(h, w, time, 0));
            if (w != 1) times[h][w-1][3] = min(times[h][w-1][3], time+60);
      }  
      if (k == 1){
            if (h != m) times[h+1][w][3] = min(times[h+1][w][3], time+60);
            min(times[h][w][3], time+getcross(h, w, time, 1));
            if (w != n) times[h][w+1][0] = min(times[h][w+1][0], time+60);
            min(times[h][w][0], time+getcross(h, w, time, 0));
      }   
      if (k == 0){
            if (h != m) times[h+1][w][2] = min(times[h+1][w][2], time+60);
            times[h][w][2] = min(times[h][w][2], time+getcross(h, w, time, 1));
            times[h][w][1] = min(times[h][w][1], time+getcross(h, w, time, 0));
            if (w != 1) times[h][w-1][1] = min(times[h][w-1][1], time+60);
      }
    }
    end:
        printf("%d\n", times[h][w][k]);
}
